from django.shortcuts import render, redirect
from django.http import HttpResponse

from addentry.models import Entry, Meaning
from django.db.models.query import QuerySet

from .forms import SearchForm

# Create your views here.


# index.html-in-chief. as a search tool.
def index_search(request):
    search_form = SearchForm()

    context = {
        'form' : search_form
    }

    if request.method == "POST":
        regForm = SearchForm(request.POST)
        if regForm.is_valid():
            option = regForm.cleaned_data['choice_field']
            search_content = regForm.cleaned_data["search_content"]

            if option == 'Gaeilge':
                print("123354")
                return redirect("ga_search", entry=search_content)
        
            if option == 'Explanation':
                # TODO
                return HttpResponse("TODO")

    
    return render(request, "index.html", context)

# return Gaeilge search result
def ga_search(request, entry):
    entry_list = Entry.objects.filter(Gaeilge=entry)
    entry_id_list= list(map(lambda x : x.id, entry_list))
    meaning_result_list = list(map(lambda x : Meaning.objects.filter(Entry=x), entry_id_list))

    def flatten_sentence(e):
        result = e.Meaning_content
        if e.Exam_Sentence1 != None:
            result += (" " + e.Exam_Sentence1 + " " + e.Exam_Sentence1_zh)
        if e.Exam_Sentence2 != None:
            result += (" "  + e.Exam_Sentence2 + " " +e.Exam_Sentence2_zh)
        if e.Exam_Sentence3 != None:
            result += (" "  + e.Exam_Sentence3 + " " + e.Exam_Sentence3_zh)
        return result



    def tree_mapping(func, tree):
        from django.db.models.query import QuerySet
        if isinstance(tree, QuerySet) or isinstance(tree, list):
            if isinstance(tree, QuerySet):
                tree = list(tree)
                
            result = []
            for i in tree:
                result.append(tree_mapping(func,i))
            return result
        else:
            return func(tree)
    
    meaning_result_list_sent_flattened = tree_mapping(flatten_sentence, meaning_result_list)

    #TODO


    return HttpResponse(meaning_result_list_sent_flattened.__str__)